SystemOrganization addCategory: #'EjerciciosPoo-Distance'!

Object subclass: #Distance
	instanceVariableNames: 'unit amount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Distance'!

!Distance class methodsFor: 'as yet unclassified' stamp: 'GrossodelSel 5/23/2012 18:14'!
newWithAmmount:aMeasure of:aUnit

	|distance|
	distance := Distance new.
	distance initializeWithAmmount: aMeasure  of: aUnit.
	^distance.! !

!Distance methodsFor: 'arithmetic' stamp: 'GrossodelSel 5/23/2012 19:06'!
* aNumber 
	
	^ Distance newWithAmmount: amount * aNumber of: unit.! !

!Distance methodsFor: 'arithmetic' stamp: 'GrossodelSel 5/23/2012 19:00'!
+ anotherDistance
	
	| anotherDistanceInTheSameUnit |
	
	anotherDistanceInTheSameUnit := anotherDistance convertTo: unit.
	^ Distance newWithAmmount: anotherDistanceInTheSameUnit amount + amount  of: unit.! !

!Distance methodsFor: 'arithmetic' stamp: 'GrossodelSel 5/23/2012 19:04'!
- anotherDistance
	
	^ self + anotherDistance negated.! !

!Distance methodsFor: 'arithmetic' stamp: 'GrossodelSel 5/23/2012 19:08'!
/ aNumber 

	^ self * (1/aNumber).
! !

!Distance methodsFor: 'comparing' stamp: 'GrossodelSel 5/23/2012 19:12'!
< aDistance 
	
	^ amount < ((aDistance convertTo: unit) amount).! !

!Distance methodsFor: 'comparing' stamp: 'GrossodelSel 5/23/2012 20:30'!
<= aDistance 
	
	^ self < aDistance or: [self = aDistance].! !

!Distance methodsFor: 'comparing' stamp: 'GrossodelSel 5/23/2012 20:05'!
= anotherObject

	self class = anotherObject class
		ifFalse: [^ false].
	^ (self convertTo:anotherObject unit) amount = anotherObject amount.! !

!Distance methodsFor: 'comparing' stamp: 'GrossodelSel 5/23/2012 20:31'!
> aDistance 

	^ (self <= aDistance) not.! !

!Distance methodsFor: 'comparing' stamp: 'GrossodelSel 5/23/2012 20:31'!
>= aDistance 

	^ (self < aDistance) not. ! !

!Distance methodsFor: 'accessing' stamp: 'GrossodelSel 5/23/2012 20:05'!
amount

	^ amount! !

!Distance methodsFor: 'comparing' stamp: 'GrossodelSel 5/23/2012 19:26'!
between: aDistance and: aDistance2 

	^ aDistance < self and: [self < aDistance2].! !

!Distance methodsFor: 'converting' stamp: 'GrossodelSel 5/23/2012 18:38'!
convertTo:aUnit

	|newRepresentationOfTheSameDistance|
	
	newRepresentationOfTheSameDistance := Distance newWithAmmount: (unit convertAmount: amount to: aUnit) of: aUnit.
	^newRepresentationOfTheSameDistance.! !

!Distance methodsFor: 'comparing' stamp: 'GrossodelSel 5/23/2012 20:58'!
hash

	 ^ (self convertTo: (Unit millimeter)) printString hash.! !

!Distance methodsFor: 'initializing' stamp: 'GrossodelSel 5/23/2012 18:38'!
initializeWithAmmount:anAmmount of:aUnit

	amount := anAmmount.
	unit := aUnit.
	
	^ self.! !

!Distance methodsFor: 'comparing' stamp: 'GrossodelSel 5/23/2012 20:58'!
max: aDistance
	
	| max |
	
"	Solucion alternativa sin if:
	
	distances := LinkedList new.
	distances add: aDistance.
	distances add: self.
	max :=  distances detect: [ :a | a >= self]."

	max := self.
	(self < aDistance) ifTrue: [max := aDistance].
	
	^ max.
! !

!Distance methodsFor: 'comparing' stamp: 'GrossodelSel 5/23/2012 19:23'!
min: aDistance

	| min |

	min := self.
	(self > aDistance) ifTrue: [min := aDistance].
	
	^ min.! !

!Distance methodsFor: 'converting' stamp: 'GrossodelSel 5/23/2012 20:05'!
negated

	^ Distance newWithAmmount: -1 * amount  of: unit.! !

!Distance methodsFor: 'printing' stamp: 'GrossodelSel 5/23/2012 20:05'!
printOn: aStream

	amount printOn: aStream.
	aStream nextPutAll: (' ', (unit unitNameForAmount: amount)).! !

!Distance methodsFor: 'as yet unclassified' stamp: 'GrossodelSel 5/23/2012 19:28'!
to: aDistance 

	^ IntervalOfDistances newFrom: self to: aDistance.! !

!Distance methodsFor: 'as yet unclassified' stamp: 'GrossodelSel 5/23/2012 19:40'!
to: aDistance by: aStepDistance 
	
	^ IntervalOfDistances newFrom: self to: aDistance by: aStepDistance.! !

!Distance methodsFor: 'accessing' stamp: 'GrossodelSel 5/23/2012 20:05'!
unit

	^ unit! !

Object subclass: #IntervalOfDistances
	instanceVariableNames: 'from to by'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Distance'!

!IntervalOfDistances class methodsFor: 'as yet unclassified' stamp: 'GrossodelSel 5/23/2012 20:28'!
newFrom: aDistance to: anotherDistance

	| aNewInterval byDistance |
	
	byDistance := Distance newWithAmmount: 1 of: aDistance unit.
	
	^ IntervalOfDistances newFrom: aDistance to: anotherDistance by: byDistance.! !

!IntervalOfDistances class methodsFor: 'as yet unclassified' stamp: 'GrossodelSel 5/23/2012 19:38'!
newFrom: aDistance to: anotherDistance by: aStepDistance

	| aNewInterval |
	
	aNewInterval := IntervalOfDistances new.
	aNewInterval initializeFrom: aDistance to: anotherDistance by: aStepDistance.
	
	^ aNewInterval.! !

!IntervalOfDistances methodsFor: 'accessing' stamp: 'GrossodelSel 5/23/2012 20:26'!
by

	^ by.! !

!IntervalOfDistances methodsFor: 'enumerating' stamp: 'GrossodelSel 5/23/2012 20:03'!
do: aBlockClosure

	| currentDistance |
	
	currentDistance := from.
	self size timesRepeat: [ aBlockClosure value: currentDistance. currentDistance := currentDistance + by ].
	! !

!IntervalOfDistances methodsFor: 'accessing' stamp: 'GrossodelSel 5/23/2012 19:32'!
from
	
	^ from.! !

!IntervalOfDistances methodsFor: 'initializing' stamp: 'GrossodelSel 5/23/2012 19:37'!
initializeFrom: aDistance to: anotherDistance by: aStepDistance
	
	from := aDistance.
	to := anotherDistance.
	by := aStepDistance.! !

!IntervalOfDistances methodsFor: 'as yet unclassified' stamp: 'GrossodelSel 5/23/2012 19:53'!
size

	| distanceBetweenLimits |
	
	distanceBetweenLimits := (to - from) convertTo: by unit.
	^ (distanceBetweenLimits / (by amount)) amount + 1.! !

!IntervalOfDistances methodsFor: 'accessing' stamp: 'GrossodelSel 5/23/2012 19:33'!
to
	
	^ to.! !

Object subclass: #Unit
	instanceVariableNames: 'name millimeterScale'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Distance'!

!Unit class methodsFor: 'as yet unclassified' stamp: 'GrossodelSel 5/23/2012 20:25'!
centimeter

	^Unit newWithName: 'centimeter' millimeterScale: 10.
	! !

!Unit class methodsFor: 'as yet unclassified' stamp: 'GrossodelSel 5/23/2012 20:25'!
decameter

	^Unit newWithName: 'decameter' millimeterScale: 10000.! !

!Unit class methodsFor: 'as yet unclassified' stamp: 'GrossodelSel 5/23/2012 20:25'!
decimeter
	
	^Unit newWithName: 'decimeter' millimeterScale: 100.! !

!Unit class methodsFor: 'as yet unclassified' stamp: 'GrossodelSel 5/23/2012 20:25'!
hectometer
	
	^Unit newWithName: 'hectometer' millimeterScale: 100000.! !

!Unit class methodsFor: 'as yet unclassified' stamp: 'GrossodelSel 5/23/2012 20:25'!
kilometer
	
	^Unit newWithName: 'kilometer' millimeterScale: 1000000.! !

!Unit class methodsFor: 'as yet unclassified' stamp: 'GrossodelSel 5/23/2012 20:25'!
meter
	
	^Unit newWithName: 'meter' millimeterScale: 1000.! !

!Unit class methodsFor: 'as yet unclassified' stamp: 'GrossodelSel 5/23/2012 20:25'!
millimeter
	
	^Unit newWithName: 'millimeter' millimeterScale: 1.! !

!Unit class methodsFor: 'as yet unclassified' stamp: 'GrossodelSel 5/23/2012 20:26'!
newWithName: aName millimeterScale: anAmountOfMillimeters

	| aNewUnit |
	
	aNewUnit := Unit new.
	aNewUnit initializeWithName: aName millimeterScale: anAmountOfMillimeters.
	^ aNewUnit.! !

!Unit methodsFor: 'comparing' stamp: 'GrossodelSel 5/23/2012 20:23'!
= anotherUnit

	 ^ name = anotherUnit privateName and: [millimeterScale = anotherUnit privateMillimeterScale].! !

!Unit methodsFor: 'converting' stamp: 'GrossodelSel 5/23/2012 20:25'!
convertAmount: anAmmount to: aUnit 

	^ anAmmount * millimeterScale / aUnit privateMillimeterScale.! !

!Unit methodsFor: 'initializing' stamp: 'GrossodelSel 5/23/2012 20:24'!
initializeWithName: aUnitName millimeterScale: anAmountOfMillimeters
	
	millimeterScale := anAmountOfMillimeters.
	name := aUnitName.! !

!Unit methodsFor: 'printing' stamp: 'GrossodelSel 5/23/2012 17:59'!
printOn: aStream
	
	aStream nextPutAll: name.! !

!Unit methodsFor: 'accessing' stamp: 'GrossodelSel 5/23/2012 20:25'!
privateMillimeterScale

	^ millimeterScale.! !

!Unit methodsFor: 'accessing' stamp: 'GrossodelSel 5/23/2012 20:25'!
privateName

	^ name.! !

!Unit methodsFor: 'as yet unclassified' stamp: 'GrossodelSel 5/23/2012 18:37'!
unitNameForAmount: anAmmount
	
	| aUnitForAmmount |
	aUnitForAmmount := name.
	anAmmount = 1 ifFalse: [ aUnitForAmmount := aUnitForAmmount , 's'].
	^ aUnitForAmmount.! !

TestCase subclass: #DistanceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Distance'!

!DistanceTest methodsFor: 'distance units' stamp: 'GrossodelSel 5/23/2012 18:18'!
centimeter
	
	^ Unit centimeter.! !

!DistanceTest methodsFor: 'distance units' stamp: 'GrossodelSel 5/23/2012 18:18'!
decameter
	
	^ Unit decameter.! !

!DistanceTest methodsFor: 'distance units' stamp: 'GrossodelSel 5/23/2012 18:18'!
decimeter
	
	^ Unit decimeter.! !

!DistanceTest methodsFor: 'distance units' stamp: 'HernanWilkinson 4/18/2011 16:07'!
distanceUnits 

	"Quin se anima a explicar cmo funciona este mtodo? 
	Por qu est hecho as? 
	Ver distanceUnits... se puede mejorar algo entre estos dos mtodos?"

	| unitsCategory unitsMessageNames |
	
	unitsCategory := self class organization categoryOfElement: thisContext method selector.
	unitsMessageNames := (self class organization listAtCategoryNamed:  unitsCategory) reject: [ :aMessageName | aMessageName = thisContext method selector ].
	
	 ^ unitsMessageNames collect: [ :aMessageName | self perform: aMessageName ]
	
! !

!DistanceTest methodsFor: 'distance measures' stamp: 'GrossodelSel 5/23/2012 19:13'!
distancesExamples 

	"Quin se anima a explicar cmo funciona este mtodo? 
	Por qu est hecho as? 
	Ver distanceUnits... se puede mejorar algo entre estos dos mtodos?"
	
	| distancesCategory distancesMessageNames |
	
	distancesCategory := self class organization categoryOfElement: thisContext method selector.
	distancesMessageNames := (self class organization listAtCategoryNamed:  distancesCategory) reject: [ :aMessageName | aMessageName = thisContext method selector ].
	
	 ^ distancesMessageNames collect: [ :aMessageName | self perform: aMessageName ]
	
! !

!DistanceTest methodsFor: 'distance units' stamp: 'GrossodelSel 5/23/2012 18:18'!
hectometer
	
	^ Unit hectometer.! !

!DistanceTest methodsFor: 'distance units' stamp: 'GrossodelSel 5/23/2012 18:17'!
kilometer
	
	^ Unit kilometer.! !

!DistanceTest methodsFor: 'distance units' stamp: 'GrossodelSel 5/23/2012 18:17'!
meter

	 ^ Unit meter.! !

!DistanceTest methodsFor: 'distance units' stamp: 'GrossodelSel 5/23/2012 18:17'!
millimeter
	
	^ Unit millimeter.! !

!DistanceTest methodsFor: 'distance measures' stamp: 'GrossodelSel 5/23/2012 19:03'!
minusOneMeter 
	
	^Distance newWithAmmount: -1 of: Unit meter.! !

!DistanceTest methodsFor: 'distance measures' stamp: 'GrossodelSel 5/23/2012 18:15'!
oneCentimeter
	
	^ Distance newWithAmmount: 1 of: Unit centimeter.! !

!DistanceTest methodsFor: 'distance measures' stamp: 'GrossodelSel 5/23/2012 18:16'!
oneHundredCentimeters
	
	^Distance newWithAmmount: 100 of: Unit centimeter.! !

!DistanceTest methodsFor: 'distance measures' stamp: 'GrossodelSel 5/23/2012 18:16'!
oneMeter

	^Distance newWithAmmount: 1 of: Unit meter.! !

!DistanceTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/18/2011 15:04'!
test01ObjectsRepresentingSameDistanceShouldBeEqual

	self assert: self oneMeter = self oneMeter.
	self assert: self oneHundredCentimeters = self oneHundredCentimeters.
	

! !

!DistanceTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/18/2011 16:50'!
test02DiferentDistancesShouldNotBeEqual

	self deny: self oneMeter = self twoMeters.
	self deny: self twoMeters = self oneMeter! !

!DistanceTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/18/2011 16:50'!
test03SameDistanceExpressWithDifferentUnitsShouldBeEqual

	self assert: self oneMeter = self oneHundredCentimeters.
	self assert: self twoMeters = self twoHundredCentimeters.

! !

!DistanceTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/19/2011 10:28'!
test04EqualsShouldBeCommutative

	self assert: (self oneMeter = self oneHundredCentimeters and: [ self oneHundredCentimeters = self oneMeter ]).
	self assert: (self twoMeters = self twoHundredCentimeters and:  [ self twoHundredCentimeters = self twoMeters ]).

! !

!DistanceTest methodsFor: '2 - Converting/accesing/printing' stamp: 'GrossodelSel 5/23/2012 18:21'!
test05UnitStringRepresentationShouldBeHumanReadable

	self assert: self meter printString = 'meter'.
	self assert: self centimeter printString = 'centimeter'.
	self assert: self decimeter printString = 'decimeter'.
	self assert: self millimeter printString = 'millimeter'.
	self assert: self decameter printString = 'decameter'.
	self assert: self hectometer printString = 'hectometer'.
	self assert: self kilometer printString = 'kilometer'.	! !

!DistanceTest methodsFor: '2 - Converting/accesing/printing' stamp: 'GrossodelSel 5/23/2012 18:35'!
test06DistanceStringRepresentationShouldBeHumanReadable

	self assert: self oneMeter printString = '1 meter'.
	self assert: self twoMeters printString = '2 meters'.
	self assert: self oneHundredCentimeters printString = '100 centimeters'.
	
! !

!DistanceTest methodsFor: '2 - Converting/accesing/printing' stamp: 'HernanWilkinson 4/19/2011 10:26'!
test07aDistanceAmountShouldBeTheExpectedAmount

	self assert: self oneMeter amount = 1.
	self assert: self twoMeters amount = 2.
	self assert: self oneHundredCentimeters amount = 100.
	self assert: self twoHundredCentimeters amount = 200.
! !

!DistanceTest methodsFor: '2 - Converting/accesing/printing' stamp: 'HernanWilkinson 4/19/2011 10:27'!
test07bDistanceUnitShouldBeTheExpectedUnit

	self assert: self oneMeter unit = self meter.
	self assert: self twoMeters unit = self meter.
	self assert: self oneHundredCentimeters unit = self centimeter.
	self assert: self twoHundredCentimeters unit = self centimeter.! !

!DistanceTest methodsFor: '2 - Converting/accesing/printing' stamp: 'HernanWilkinson 4/19/2011 10:27'!
test07cDifferentDistanceUnitsShouldBeDifferent

	| unitsGroupedByItself |
	
	unitsGroupedByItself := self distanceUnits groupedBy: [ :aDistanceUnit | aDistanceUnit ].
	self assert: (unitsGroupedByItself allSatisfy: [:aCollectionOfUnit | aCollectionOfUnit size = 1] )
! !

!DistanceTest methodsFor: '2 - Converting/accesing/printing' stamp: 'HernanWilkinson 4/19/2011 10:27'!
test07dDistancesCanBeConvertedToDifferentUnits

	"A partir de los test de igualdad, se deben haber dado cuenta que debemos poder
	convertir distancias a distintas unidades... y que ademas dos distancias de distintas unidades
	pueden ser iguales... Por lo tanto por qu no hacer esta caracteristica de las distancias explicita?
	Veran que luego se torna muy util
	
	Respecto de como esta escrito el test, para no tener que escribir los assert para oneMeter y oneHundredCentimeters 
	creo un array y lo recorro... Se podria escribir menos aun en este test?
	
	Y por qu se asserta sobre el amount y luego la unidad y no directametne sobre la distancia completa. ej:
	self assert: (aDistance converTo: self meter) = self oneMeter
	"
	
	(Array with: self oneMeter with: self oneHundredCentimeters) do: [ :aDistance |
		self assert: (aDistance convertTo: self meter) amount = 1.
		self assert: (aDistance convertTo: self meter) unit = self meter.
		
		self assert: (aDistance convertTo: self decimeter) amount = 10.
		self assert: (aDistance convertTo: self decimeter) unit = self decimeter.
		
		self assert: (aDistance convertTo: self centimeter) amount = 100.
		self assert: (aDistance convertTo: self centimeter) unit = self centimeter.
		
		self assert: (aDistance convertTo: self millimeter) amount = 1000.
		self assert: (aDistance convertTo: self millimeter) unit = self millimeter.
	
		self assert: (aDistance convertTo: self decameter) amount = (1/10).
		self assert: (aDistance convertTo: self decameter) unit = self decameter.
		
		self assert: (aDistance convertTo: self hectometer) amount = (1/100).
		self assert: (aDistance convertTo: self hectometer) unit = self hectometer.
	
		self assert: (aDistance convertTo: self kilometer) amount = (1/1000).
		self assert: (aDistance convertTo: self kilometer) unit = self kilometer ]! !

!DistanceTest methodsFor: '3 - Test equality - implementation details' stamp: 'HernanWilkinson 4/19/2011 10:27'!
test08aComparingDistancesWithOtherObjectsShouldReturnFalse

	"El igual no debe generar ningun tipo de error por mas que se comparen objetos
	de distintos tipos
	Fijense como se crea una instancia de Object sin ningun tipo de problema... qu representa?"

	self deny: self oneMeter = Object new.
	self deny: Object new = self oneMeter! !

!DistanceTest methodsFor: '3 - Test equality - implementation details' stamp: 'HernanWilkinson 4/19/2011 10:27'!
test08bDistancesThatAreEqualShouldReturnTheSameHash

	"Debido a como funcionan los diccionarios, cuando dos objetos son iguales deben
	tener es mismo hash. La inversa no es verdad"
	
	self assert: self oneMeter hash=self oneMeter hash.
	self assert: self oneMeter hash=self oneHundredCentimeters hash.

	
	
! !

!DistanceTest methodsFor: '3 - Test equality - implementation details' stamp: 'HernanWilkinson 4/19/2011 10:27'!
test08cCopiesOfTheSameDistanceShouldBeEqual

	"Dos objetos que ocupan distintas posiciones de memoria pero representan
	la misma entidad de la realidad, deben devolver true cuando se los compara por igual, puesto
	que representan la misma entidad de la realidad.
	Por lo tanto, el mensaje #= significa 'representan el mismo ente de la realidad?'
	mientras que el mensaje #== significa ocupan la misma posicion de memoria?"

	| originalOneMeter copiedOneMeter |

	"Al objeto oneMeter lo copio para asegurarme de tener uno oneMeter en otra posicion de memoria"

	originalOneMeter := self oneMeter.
	copiedOneMeter := originalOneMeter copy.

	"Me aseguro que ocupen distinta posicion de memoria"
	self deny: originalOneMeter == copiedOneMeter.

	"Ahora me aseguro que sean iguales"
	self assert: originalOneMeter = copiedOneMeter! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:34'!
test09AddingDistancesOfSameUnitShouldReturnADistanceRepresentingTheAddingDistances

	self assert: (self oneMeter + self oneMeter) = self twoMeters

! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:34'!
test10AddingDistancesOfDifferentUnitShouldReturnADistanceRepresentingTheAddingDistances

	self assert: (self oneMeter + self oneHundredCentimeters) = self twoMeters.
	self assert: (self oneMeter + self oneHundredCentimeters) = self twoHundredCentimeters.

! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:35'!
test11AddingDistancesIsCommutative

	self assert: (self oneMeter + self twoMeters)=(self twoMeters + self oneMeter)


! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:35'!
test12AddingDistancesIsAssociative

	self assert: 
		((self oneMeter + self oneMeter) + self twoMeters) = 
		(self oneMeter + (self oneMeter + self twoMeters))


! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:41'!
test12aAddingDistancesKeepsDistanceInmutability

	| oneMeter |
	
	oneMeter := self oneMeter.
	oneMeter + oneMeter.
	
	self assert: oneMeter = self oneMeter.
	


! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:36'!
test13aNegatingADistanceNegatesItsAmount

	self assert: self oneMeter negated = self minusOneMeter.
	
! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:36'!
test13bNegatingADistanceIsReflective

	self assert: self oneMeter negated negated=self oneMeter.
	
! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:38'!
test14SubtractingDistancesOfSameUnitShouldReturnADistanceRepresentingTheSubtractedDistances

	self assert: (self twoMeters - self oneMeter) = self oneMeter.
	self assert: (self oneMeter - self oneMeter) = self zeroMeters.
	self assert: (self oneMeter - self twoMeters) = self oneMeter negated
	

	! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:40'!
test15SubtractingDistancesOfDifferentUnitShouldReturnADistanceRepresentingTheSubtractedDistances

	self assert: (self twoMeters - self oneHundredCentimeters) = self oneMeter.
	self assert: (self oneMeter - self oneHundredCentimeters) = self zeroMeters.
	self assert: (self oneHundredCentimeters - self twoMeters) = self oneMeter negated
	

	! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:40'!
test16SubtractingDistancesIsAssociative

	self assert: 
		((self twoMeters - self oneMeter) - self oneMeter) = 
		(self twoMeters - (self oneMeter + self oneMeter)).

	

	! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:41'!
test16aSubtractingDistancesKeepsDistanceInmutability

	| oneMeter |
	
	oneMeter := self oneMeter.
	oneMeter - oneMeter.
	
	self assert: oneMeter = self oneMeter.
	


! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:45'!
test17aDistancesCanBeMultiplyByAnInteger

	self assert: self oneMeter * 1 = self oneMeter.
	self assert: self oneMeter * 2 = self twoMeters.
	self assert: self oneMeter * 0 = self zeroMeters.
! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'GrossodelSel 5/23/2012 19:06'!
test17bDistancesCanBeMultiplyByAFraction

	self assert: (self oneMeter * (2/3)) amount = (2/3).
	self assert: (self twoMeters * (2/3)) amount = (2 * (2/3)).
! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'GrossodelSel 5/23/2012 19:07'!
test17cDistancesCanBeMultiplyByAFloat

	self assert: (self oneMeter * 2.5) amount = 2.5.
	self assert: (self twoMeters * 2.5) amount = (2 * 2.5).
! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:47'!
test18MultiplicationKeepsDistanceInmutability

	| oneMeter |
	
	oneMeter := self oneMeter.
	oneMeter * 2.
	
	self assert: oneMeter = self oneMeter.
	


! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:48'!
test19aDistancesCanBeDividedByAnInteger

	self assert: (self oneMeter / 1) = self oneMeter.
	self assert: (self twoMeters / 2) = self oneMeter.


! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/21/2011 17:24'!
test19bDistancesCanBeDividedByAFraction

	self assert: (self twoMeters / (1/3)) amount = 6.




! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:49'!
test19cDistancesCanBeDividedByAFloat

	self assert: (self twoMeters / 2.5) amount = (2/2.5).




! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:49'!
test20DivisionKeepsDistanceInmutability

	| oneMeter |
	
	oneMeter := self oneMeter.
	oneMeter / 2.
	
	self assert: oneMeter = self oneMeter.
	


! !

!DistanceTest methodsFor: '5 - Test magnitude protocol' stamp: 'GrossodelSel 5/23/2012 19:13'!
test21DistancesProvideATotalOrder

	self assert: (self distancesExamples allSatisfy: [ :aDistance | aDistance < (aDistance + self oneMeter)])

! !

!DistanceTest methodsFor: '5 - Test magnitude protocol' stamp: 'GrossodelSel 5/23/2012 19:13'!
test22DistancesCanBeComparedWithGreaterThan

	self assert: (self distancesExamples allSatisfy: [ :aDistance | (aDistance + self oneMeter) > aDistance ])
! !

!DistanceTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/18/2011 16:12'!
test23DistancesCanBeComparedWithLessThanOrEqual

	self assert: (self distancesExamples allSatisfy: [ :aDistance | aDistance <= aDistance and: [aDistance <= (aDistance + self oneMeter)]])

	
! !

!DistanceTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/18/2011 16:13'!
test24DistancesCanBeComparedWithGreaterThanOrEqual

	self assert: (self distancesExamples allSatisfy: [ :aDistance | aDistance >= aDistance and: [(aDistance + self oneMeter) >= aDistance]])
! !

!DistanceTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/18/2011 16:13'!
test25MaxReturnsTheMaximumBetweenTwoDistances

	self assert: (self twoMeters max: self oneMeter) = self twoMeters.
	self assert: (self oneMeter max: self twoMeters) = self twoMeters.

	self assert: (self twoMeters max: self oneHundredCentimeters) = self twoMeters.
	self assert: (self oneHundredCentimeters max: self twoMeters) = self twoMeters.

	
! !

!DistanceTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/18/2011 16:14'!
test26MinReturnsTheMinimumBetweenTwoDistances

	self assert: (self twoMeters min: self oneMeter) = self oneMeter.
	self assert: (self oneMeter min: self twoMeters) = self oneMeter.

	self assert: (self twoMeters min: self oneHundredCentimeters) = self oneHundredCentimeters.
	self assert: (self oneHundredCentimeters min: self twoMeters) = self oneHundredCentimeters.

	
! !

!DistanceTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/18/2011 16:14'!
test27BetweenAndReturnsTrueIfADistanceIsBetweenOtherTwoDistances

	self assert: (self oneMeter between: self zeroMeters and: self twoMeters).
	self assert: (self oneHundredCentimeters between: self zeroMeters and: self twoMeters).
	
	self deny: (self twoMeters between: self zeroMeters and: self oneMeter).
	self deny: (self twoHundredCentimeters between: self zeroMeters and: self oneMeter).

! !

!DistanceTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/18/2011 16:16'!
test28IntervalOfDistancesCanBeCreatedBecauseTheyDefineATotalOrder

	self assert: (self oneMeter to: self twoMeters) from=self oneMeter.
	self assert: (self oneMeter to: self twoMeters) to=self twoMeters.
	self assert: (self oneMeter to: self twoMeters) by=self oneMeter.	

	self assert: (self oneHundredCentimeters to: self twoMeters) from=self oneMeter.
	self assert: (self oneHundredCentimeters to: self twoMeters) to=self twoMeters.
	self assert: (self oneHundredCentimeters to: self twoMeters) by=self oneCentimeter.	
	! !

!DistanceTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/18/2011 16:16'!
test29DistanceIntervalStepCanBeAnyDistance

	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) from=self zeroMeters.
	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) to=(self twoMeters * 2).
	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) by=self twoMeters.

	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) from=(self twoMeters * 2).
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) to=self zeroMeters.
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) by=self twoMeters negated

	! !

!DistanceTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/18/2011 16:17'!
test30DistanceIntervalSizeReturnsTheNumberOfDistancesOfTheInterval

	self assert: (self zeroMeters to: (self twoMeters * 2) ) size =5.
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self oneMeter negated) size =5.
! !

!DistanceTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/18/2011 16:19'!
test31DistanceIntervalCanBeEnumeratedUsingDo

	| value |
	
	value := 1.
	(self oneMeter to: (self oneMeter * 10)) do: [ :aDistance |
		self assert: aDistance amount = value.
		value := value + 1 ].
	
	self assert: value = 11
! !

!DistanceTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/18/2011 16:27'!
test32DistanceIntervalCanBeEnumeratedWithSpecificStep

	| value initialDistance byDistance finalDistance |
	
	initialDistance := self oneMeter.
	byDistance := self twoMeters.
	finalDistance := initialDistance * 9.
	value := initialDistance amount.
		
	(initialDistance to: finalDistance by:  byDistance) do: [ :aDistance |
		self assert: aDistance amount = value.
		value := value + byDistance amount ].
	
	self assert:  value = (finalDistance amount + byDistance amount)
! !

!DistanceTest methodsFor: 'distance measures' stamp: 'GrossodelSel 5/23/2012 18:15'!
twoHundredCentimeters
	
	^ Distance newWithAmmount: 200 of: Unit centimeter.! !

!DistanceTest methodsFor: 'distance measures' stamp: 'GrossodelSel 5/23/2012 18:15'!
twoMeters
	
	^ Distance newWithAmmount: 2 of: Unit meter.! !

!DistanceTest methodsFor: 'distance measures' stamp: 'GrossodelSel 5/23/2012 18:16'!
zeroMeters

	^ Distance newWithAmmount: 0 of: Unit meter.! !
